function [subCord, coocBox, coocCenter, cooc1] = adjustCooc(j,im,cooc1, subCord, coocBox, imgCmpCenter, coocCenter, spatCenter,imgRows,imgCols,binsCooc)
d1 = sqrt(sum((coocCenter - imgCmpCenter ).^2));
d2 = sqrt(sum((coocCenter - spatCenter ).^2));
r = sqrt(sum((imgCmpCenter - spatCenter ).^2));

if( d1>1.5*r && d2>1.5*r && (d1+d2)/2>8)
    disp([num2str(j),': cooc adjusting!']);
    box = [coocBox(2,1)-coocBox(1,1)+1 , coocBox(2,2)-coocBox(1,2)+1];
    coocCenter = imgCmpCenter + ((imgCmpCenter - spatCenter)./2);
    
    minr = uint16(coocCenter(1) - double(box(1))/2);
    maxr = minr + coocBox(2,1) - coocBox(1,1);
    %maxr = minr + box(1);
    minc = uint16(coocCenter(2) - double(box(2))/2);
    maxc = minc + coocBox(2,2) - coocBox(1,2);
    %maxc = minc + box(2);
    coocBox = [minr,minc;maxr,maxc];
    subCord = [ max([1 , coocBox(1,1) - box(1)]) , max([1 , coocBox(1,2) - box(2)]); min([imgRows , coocBox(2,1) + box(1)]) , min([imgCols , coocBox(2,2) + box(2)])];
    %imgCmpBox = imgCmpBox + [subCord(1,:);subCord(1,:)] - 1;
end
im = im(coocBox(1,1):coocBox(2,1),coocBox(1,2):coocBox(2,2),:);
coocIm = bitshift(im,-log(256/binsCooc)/log(2));
coocIm = coocIm + 1;
cooc = makeCooc(double(coocIm), binsCooc);
cooc1 = cooc1.*0.0 + cooc;