function [box,maxx,coocOut,z,modelInUse] = bestCoocFit(im,cooc,box,bins,res,modelInUse,frameNr,newModFrq)
numModels = length(cooc);
scoreM = zeros(numModels,1);

if(res==1)
    bredde = box(2);
    hoyde = box(1);


    [rows cols dim] = size(im);

    imd = double(im);
    %roterer frste rad
    for i=1:dim
        imRot(:,:,i) = rot90(imd(:,1:bredde,i));
    end
    maxx = 0;
    box = [1,1;1,1];
    i=1;
    s(1).im = imd(1:hoyde,1:bredde,:);
    s(1).box = [1,1;hoyde,bredde];
    s(1).co = getCoocMatrix(s(1).im,bins);
    if(mod(frameNr-1,newModFrq)==0)
        for m=1:numModels
            scoreM(m) = getCosineAngle(cooc(m).cooc,s(1).co);
        end
        modelInUse = find(scoreM==max(scoreM));
        s(1).score = max(scoreM);
    else
        s(1).score = getCosineAngle(cooc(modelInUse).cooc,s(1).co);
    end
    
    z(1,1) = s(1).score;
    for j=1:(rows-hoyde+1)
        if(j ~= 1)
            s((cols+1-bredde)*(j-1)+1).im = imd(j:j+hoyde-1,1:bredde,:);
            s((cols+1-bredde)*(j-1)+1).box = [j,1;j+hoyde-1,bredde];
            s((cols+1-bredde)*(j-1)+1).co = getCoocMatrixIt(imRot(:,j-1:j+hoyde-2,:), s((cols+1-bredde)*(j-2)+1).co, imRot(:,j:j+hoyde-1,:),bins);
            if(mod(frameNr-1,newModFrq)==0)
                for m=1:numModels
                    scoreM(m) = getCosineAngle(cooc(m).cooc,s((cols+1-bredde)*(j-1)+1).co);
                end
                modelInUse = find(scoreM==max(scoreM));
                s((cols+1-bredde)*(j-1)+1).score = max(scoreM);
            else
                s((cols+1-bredde)*(j-1)+1).score = getCosineAngle(cooc(modelInUse).cooc,s((cols+1-bredde)*(j-1)+1).co);
            end
                        
            z(j,1) = s((cols+1-bredde)*(j-1)+1).score;
            s((cols+1-bredde)*(j-2)+1).co = 0;
            s((cols+1-bredde)*(j-2)+1).im = 0;
            s((cols+1-bredde)*(j-2)+1).box = 0;
            s((cols+1-bredde)*(j-2)+1).score = 0;
        end
        if s(end).score > maxx
            maxx = s(end).score;
            box = s(end).box;
            coocOut = s(end).co;
        end
        for i=2:(cols+1-bredde)
            s((cols+1-bredde)*(j-1)+i).im = imd(j:j+hoyde-1,i:i+bredde-1,:);
            s((cols+1-bredde)*(j-1)+i).box = [j,i;j+hoyde-1,i+bredde-1];
            s((cols+1-bredde)*(j-1)+i).co = getCoocMatrixIt(s((cols+1-bredde)*(j-1)+i-1).im,s((cols+1-bredde)*(j-1)+i-1).co,s((cols+1-bredde)*(j-1)+i).im,bins);
            if(mod(frameNr-1,newModFrq)==0)
                for m=1:numModels
                    scoreM(m) = getCosineAngle(cooc(m).cooc,s((cols+1-bredde)*(j-1)+i).co);
                end
                modelInUse = find(scoreM==max(scoreM));
                s((cols+1-bredde)*(j-1)+i).score = max(scoreM);
            else
                s((cols+1-bredde)*(j-1)+i).score = getCosineAngle(cooc(modelInUse).cooc,s((cols+1-bredde)*(j-1)+i).co);
            end
            
            
            z(j,i) = s((cols+1-bredde)*(j-1)+i).score;
            if s(end).score > maxx
                maxx = s(end).score;
                box = s(end).box;
                coocOut = s(end).co;
            end
            if( i > 2 ) %free memory
                s((cols+1-bredde)*(j-1)+i-1).im = 0;
                s((cols+1-bredde)*(j-1)+i-1).box = 0;
                s((cols+1-bredde)*(j-1)+i-1).co = 0;
                s((cols+1-bredde)*(j-1)+i-1).score = 0;
            end
        end
        %free memory
        s((cols+1-bredde)*(j-1)+i).im = 0;
        s((cols+1-bredde)*(j-1)+i).box = 0;
        s((cols+1-bredde)*(j-1)+i).co = 0;
        s((cols+1-bredde)*(j-1)+i).score = 0;
    end
else
    bredde = box(2);
    hoyde = box(1);

    [rows cols dim] = size(im);

    imd = double(im);
    
    maxx = 0;
    box = [1,1;1,1];
    u=1;
    v=1;
    for j=1:res:(rows-hoyde+1)
        for i=1:res:(cols+1-bredde)
            sim = imd(j:j+hoyde-1,i:i+bredde-1,:);
            sbox = [j,i;j+hoyde-1,i+bredde-1];
            sco = getCoocMatrix(sim,bins);
            
            if(mod(frameNr-1,newModFrq)==0)
                for m=1:numModels
                    scoreM(m) = getCosineAngle(cooc(m).cooc,sco);
                end
                modelInUse = find(scoreM==max(scoreM));
                sscore = max(scoreM);
            else
                sscore = getCosineAngle(cooc(modelInUse).cooc,sco);
            end
            
            z(v,u) = sscore;
            u=u+1;
            if sscore > maxx
                maxx = sscore;
                box = sbox;
                coocOut = sco;
            end
        end
        u=1;
        v=v+1;
    end
end
    