% Calculates cooccurrence matrix 
function cooc = getCoocMatrix(input,bins)
[r c d] = size(input);

cooc = zeros(1,bins);
t=1;

for dim=1:d
    out = zeros(bins);
    for i=1:r
        for j=1:c
            if(i==r && j==1)
                out(input(i,j,dim),input(i,j+1,dim)) = out(input(i,j,dim),input(i,j+1,dim)) + t;
            elseif(j==1)
                out(input(i,j,dim),input(i+1,j,dim)) = out(input(i,j,dim),input(i+1,j,dim)) + t;
                out(input(i,j,dim),input(i+1,j+1,dim)) = out(input(i,j,dim),input(i+1,j+1,dim)) + t;
                out(input(i,j,dim),input(i,j+1,dim)) = out(input(i,j,dim),input(i,j+1,dim)) + t;
            elseif(i==r && j==c)
                break;
            elseif(i==r)
                out(input(i,j,dim),input(i,j+1,dim)) = out(input(i,j,dim),input(i,j+1,dim)) + t;
            elseif(j==c)
                out(input(i,j,dim),input(i+1,j-1,dim)) = out(input(i,j,dim),input(i+1,j-1,dim)) + t;
                out(input(i,j,dim),input(i+1,j,dim)) = out(input(i,j,dim),input(i+1,j,dim)) + t;
            else
                out(input(i,j,dim),input(i+1,j-1,dim)) = out(input(i,j,dim),input(i+1,j-1,dim)) + t;
                out(input(i,j,dim),input(i+1,j,dim)) = out(input(i,j,dim),input(i+1,j,dim)) + t;
                out(input(i,j,dim),input(i+1,j+1,dim)) = out(input(i,j,dim),input(i+1,j+1,dim)) + t;
                out(input(i,j,dim),input(i,j+1,dim)) = out(input(i,j,dim),input(i,j+1,dim)) + t;
            end
        end
    end
    out = out + not(eye(bins)).*(out');
    out = out.*triu(ones(bins));
    cooc = [cooc;out];
end
cooc = cooc(2:end,:,:);
sumCooc = sum(sum(cooc));
cooc = cooc./sumCooc;