% Calculates cooccurrence matrix 
function s = getCoocMatrixIt(m,s,n,b)
[r c d] = size(m);
u=(4*r*c-3*r-3*c+2)*d;
s = s.*u;

for j=1:d
    s(b*(j-1)+m(1,1,j),m(1,2,j)) = s(b*(j-1)+m(1,1,j),m(1,2,j)) - 1;
    s(b*(j-1)+m(1,1,j),m(1+1,2,j)) = s(b*(j-1)+m(1,1,j),m(1+1,2,j)) - 1;
    s(b*(j-1)+m(1,1,j),m(1+1,1,j)) = s(b*(j-1)+m(1,1,j),m(1+1,1,j)) - 1;
    s(b*(j-1)+n(1,c,j),n(1,c-1,j)) = s(b*(j-1)+n(1,c,j),n(1,c-1,j)) + 1;
    s(b*(j-1)+n(1,c,j),n(1+1,c-1,j)) = s(b*(j-1)+n(1,c,j),n(1+1,c-1,j)) + 1;
    s(b*(j-1)+n(1,c,j),n(1+1,c,j)) = s(b*(j-1)+n(1,c,j),n(1+1,c,j)) + 1;
    s(b*(j-1)+m(r,1,j),m(r-1,2,j)) = s(b*(j-1)+m(r,1,j),m(r-1,2,j)) - 1;
    s(b*(j-1)+m(r,1,j),m(r,2,j)) = s(b*(j-1)+m(r,1,j),m(r,2,j)) - 1;
    s(b*(j-1)+n(r,c,j),n(r-1,c-1,j)) = s(b*(j-1)+n(r,c,j),n(r-1,c-1,j)) + 1;
    s(b*(j-1)+n(r,c,j),n(r,c-1,j)) = s(b*(j-1)+n(r,c,j),n(r,c-1,j)) + 1;
end
for i=2:r-1
    for j=1:d
        s(b*(j-1)+m(i,1,j),m(i-1,2,j)) = s(b*(j-1)+m(i,1,j),m(i-1,2,j)) - 1;
        s(b*(j-1)+m(i,1,j),m(i,2,j)) = s(b*(j-1)+m(i,1,j),m(i,2,j)) - 1;
        s(b*(j-1)+m(i,1,j),m(i+1,2,j)) = s(b*(j-1)+m(i,1,j),m(i+1,2,j)) - 1;
        s(b*(j-1)+m(i,1,j),m(i+1,1,j)) = s(b*(j-1)+m(i,1,j),m(i+1,1,j)) - 1;
        s(b*(j-1)+n(i,c,j),n(i-1,c-1,j)) = s(b*(j-1)+n(i,c,j),n(i-1,c-1,j)) + 1;
        s(b*(j-1)+n(i,c,j),n(i,c-1,j)) = s(b*(j-1)+n(i,c,j),n(i,c-1,j)) + 1;
        s(b*(j-1)+n(i,c,j),n(i+1,c-1,j)) = s(b*(j-1)+n(i,c,j),n(i+1,c-1,j)) + 1;
        s(b*(j-1)+n(i,c,j),n(i+1,c,j)) = s(b*(j-1)+n(i,c,j),n(i+1,c,j)) + 1;
    end
end

for k=1:size(m,3)
    s((k-1)*b+1:(k-1)*b+b,:) = s((k-1)*b+1:(k-1)*b+b,:) + not(eye(b)).*(s((k-1)*b+1:(k-1)*b+b,:)');
    s((k-1)*b+1:(k-1)*b+b,:) = s((k-1)*b+1:(k-1)*b+b,:).*triu(ones(b));
end
s = s./u;

