function [subCord, imgCmpBox, imgCmpCenter, imgCmp] = adjustImCmp(j,im, subCord, imgCmpBox, imgCmpCenter, coocCenter, spatCenter,imgRows,imgCols)
d1 = sqrt(sum((imgCmpCenter - coocCenter ).^2));
d2 = sqrt(sum((imgCmpCenter - spatCenter ).^2));
r = sqrt(sum((coocCenter - spatCenter ).^2));

if( d1>1.5*r && d2>1.5*r && (d1+d2)/2>8)
    disp([num2str(j),': imgCmp adjusting!']);
    box = [imgCmpBox(2,1)-imgCmpBox(1,1)+1 , imgCmpBox(2,2)-imgCmpBox(1,2)+1];
    imgCmpCenter = coocCenter + ((coocCenter - spatCenter)./2);
    
    minr = uint16(imgCmpCenter(1) - double(box(1))/2);
    maxr = minr + imgCmpBox(2,1) - imgCmpBox(1,1);
    %maxr = minr + box(1);
    minc = uint16(imgCmpCenter(2) - double(box(2))/2);
    maxc = minc + imgCmpBox(2,2) - imgCmpBox(1,2);
    %maxc = minc + box(2);
    imgCmpBox = [minr,minc;maxr,maxc];
    subCord = [ max([1 , imgCmpBox(1,1) - box(1)]) , max([1 , imgCmpBox(1,2) - box(2)]); min([imgRows , imgCmpBox(2,1) + box(1)]) , min([imgCols , imgCmpBox(2,2) + box(2)])];
    %imgCmpBox = imgCmpBox + [subCord(1,:);subCord(1,:)] - 1;
end
imgCmp = im(imgCmpBox(1,1):imgCmpBox(2,1),imgCmpBox(1,2):imgCmpBox(2,2),:);