function [subCord, spatBox, spatCenter, h,mu,sigma] = adjustSpat(j,h,mu,sigma, im, subCord, spatBox, imgCmpCenter, coocCenter, spatCenter,imgRows,imgCols,binsHist)
d1 = sqrt(sum((spatCenter - imgCmpCenter ).^2));
d2 = sqrt(sum((spatCenter - coocCenter ).^2));
r = sqrt(sum((imgCmpCenter - coocCenter ).^2));

if( d1>3*r && d2>3*r && (d1+d2)/2>15)
    disp([num2str(j),': spat adjusting!']);
    box = [spatBox(2,1)-spatBox(1,1)+1 , spatBox(2,2)-spatBox(1,2)+1];
    spatCenter = imgCmpCenter + ((imgCmpCenter - coocCenter)./2);
    
    minr = uint16(spatCenter(1) - double(box(1))/2);
    maxr = minr + spatBox(2,1) - spatBox(1,1);
    %maxr = minr + box(1);
    minc = uint16(spatCenter(2) - double(box(2))/2);
    maxc = minc + spatBox(2,2) - spatBox(1,2);
    %maxc = minc + box(2);
    spatBox = [minr,minc;maxr,maxc];
    subCord = [ max([1 , spatBox(1,1) - box(1)]) , max([1 , spatBox(1,2) - box(2)]); min([imgRows , spatBox(2,1) + box(1)]) , min([imgCols , spatBox(2,2) + box(2)])];
    
    im = im(spatBox(1,1):spatBox(2,1),spatBox(1,2):spatBox(2,2),:);
    [h,mu,sigma] = getPatchSpatiogram_fast(double(im), binsHist);
end
