function [box,maxx,imOut,z,modelInUse] = bestImFit(im,im0,box,modelInUse,frameNr,newModFrq)
numModels = length(im0);
scoreM = zeros(numModels,1);
bredde = box(2);
hoyde = box(1);
im = double(im);


[rows cols dim] = size(im);
imCmp = reshape(double(im0(modelInUse).im),hoyde*dim,bredde);
maxx = 0;
box = [1,1;1,1];
for j=1:(rows-hoyde+1)
    for i=1:(cols+1-bredde)
        s_im = im(j:j+hoyde-1,i:i+bredde-1,:);
        s_box = [j,i;j+hoyde-1,i+bredde-1];
        if(mod(frameNr-1,newModFrq)==0)
            for m=1:numModels
                imCmp = reshape(double(im0(m).im),hoyde*dim,bredde);
                scoreM(m) = getCosineAngle(imCmp,reshape(s_im,hoyde*dim,bredde));
            end
            modelInUse = find(scoreM==max(scoreM));
            s_score = max(scoreM);
        else
            s_score = getCosineAngle(imCmp,reshape(s_im,hoyde*dim,bredde));
        end
        z(j,i) = s_score;
        if s_score > maxx
            maxx = s_score;
            box = s_box;
            imOut = s_im;
        end
    end
end
imOut = im0;