function [boxx,maxx,h22,mu22,sigma22,z,modelInUse] = bestSpatFit(im,h1,mu1,sigma1,box,bins,res,modelInUse,frameNr,newModFrq)
numModels = length(h1);
scoreM = zeros(numModels,1);
bredde = box(2);
hoyde = box(1);
if(mod(frameNr-1,newModFrq)==0)
%     res=1;
end
[rows cols dim] = size(im);

imd = double(im);

maxx = 0;
boxx = [1,1;1,1];
i=1;
% z=zeros(rows-hoyde+1,cols+1-bredde);
u=1;v=1;
for j=1:res:(rows-hoyde+1)
    im = imd(j:j+hoyde-1,1:bredde,:);
    box = [j,1;j+hoyde-1,bredde];
    [h2,mu2,sigma2] = getSpatiogram(im, bins);
    if(mod(frameNr-1,newModFrq)==0)
        for m=1:numModels
            scoreM(m) = compareSpatiograms(h1(m).h,mu1(m).mu,sigma1(m).sigma,h2,mu2,sigma2);
        end
        modelInUseLocal = find(scoreM==max(scoreM));
        score = max(scoreM);
    else
        score = compareSpatiograms(h1(modelInUse).h,mu1(modelInUse).mu,sigma1(modelInUse).sigma,h2,mu2,sigma2);
    end
    
    z(u,v) = score;
    if score > maxx
        if(mod(frameNr-1,newModFrq)==0)
            modelInUse = modelInUseLocal;
        end
        maxx = score;
        boxx = box;
        h22 = h2;
        mu22 = mu2;
        sigma22 = sigma2;
    end
    for i=2:res:(cols+1-bredde)
        im = imd(j:j+hoyde-1,i:i+bredde-1,:);
        box = [j,i;j+hoyde-1,i+bredde-1];
        [h2,mu2,sigma2] = getSpatiogram(im, bins);
        if(mod(frameNr-1,newModFrq)==0)
            for m=1:numModels
                scoreM(m) = compareSpatiograms(h1(m).h,mu1(m).mu,sigma1(m).sigma,h2,mu2,sigma2);
            end
            modelInUseLocal = find(scoreM==max(scoreM));
            score = max(scoreM);
        else
            score = compareSpatiograms(h1(modelInUse).h,mu1(modelInUse).mu,sigma1(modelInUse).sigma,h2,mu2,sigma2);
        end
        
        v=v+1;
        z(u,v) = score;
        if score > maxx
            if(mod(frameNr-1,newModFrq)==0)
                modelInUse = modelInUseLocal;
            end
            maxx = score;
            boxx = box;
            h22 = h2;
            mu22 = mu2;
            sigma22 = sigma2;
        end
    end
    v=1;
    u=u+1;
end