clear all;
tic;
imageSizeX = 50;
imageSizeY = 50;
centerX = 25;
centerY = 25;
im = uint8(zeros(imageSizeY,imageSizeX));
for r=1:2:floor(imageSizeX/2)
    [x,y] = meshgrid(1:imageSizeY, 1:imageSizeX);
    binaryImage = sqrt((x-centerX).^2 + (y-centerY).^2) <= r;
    im = im + uint8(binaryImage);
end
image = imread('im.jpg');
image = double(image(200:200+imageSizeX-1,300:300+imageSizeY-1,:));
radi=zeros(max(max(im)),1);
for i=1:double(max(max(im)))
    disp(i);
    [rows,cols] = find(im==i);
    sum=0;
    for j=1:length(rows)
        sum = sum + image(rows(j),cols(j),1) + image(rows(j),cols(j),2) + image(rows(j),cols(j),3); 
    end
    radi(i)=sum;
end
radi=flipud(radi);

toc;